<?php

//==================================================================================
// Common subroutines
// 汎用サブルーチン (C)Woody-Rinn 氏
// (rinn さんから頂いた rnote からの抜粋コードほぼそのまま。)
//==================================================================================

function SplitPath($path,&$dir,&$fname){
	$dir = $fname = '';
	if(preg_match('/^[^\.]*[^\/]$/',$path)) $path .= '/';
	if(preg_match('/(^.*\/|^)(.*?)$/',$path,$tmp)){
		if($tmp[1]) $dir = $tmp[1];
		if($tmp[2]) $fname = $tmp[2];
	}
}

function get_XMLTag($tag,&$str){
	if(preg_match("/<$tag.*?>[[:space:]]*(.*)[[:space:]]*<\/$tag>/s",$str,$buf)) {
		return $buf[1];
	}
	return '';
}

function GetDescription($buf,$len){
	$t = get_XMLTag(TAG_DESCRIPTION,$buf);
	if(!$t) $t = get_XMLTag(TAG_TEXT,$buf);
	$t = strip_tags($t);
	$t = preg_replace("/[\t\n\x0b\x0c\r]/",'',$t);
	$trans = array('&amp;' => '&', '&quot;' => '"', '&lt;' => '<', '&gt;' => '>');
	$t = strtr($t, $trans);
	if(mb_strlen($t,SITE_CHARSET)>$len)
		 $t = mb_substr($t, 0, $len, SITE_CHARSET) . '...';
	$t = htmlspecialchars($t);
	return $t;
}

function ext_change($fname,$new_ext){
	return preg_replace('/\.[^\/\.]*$/','',$fname) . $new_ext;
}

//------------------------------------------------------
// 汎用httpアクセス関数
//（TOMOさんによる「簡易HTTPクライアント」のコードから
//    Rinn さんが紹介くださったものを元にしています。
//    TOMO さんのサイト http://www.spencernetwork.org/）
//------------------------------------------------------
function send_http($url, $method="GET", $headers="", $post=array(""), $debug=0)
{
	/* URLを分解 */
	$URL = parse_url($url);

	/* クエリー */
	if (isset($URL['query'])) {
		$URL['query'] = "?".$URL['query'];
	} else {
		$URL['query'] = "";
	}

	/* デフォルトのポートは80 */
	if (!isset($URL['port'])) $URL['port'] = 80;

	/* リクエストライン */
	$request  = $method." ".$URL['path'].$URL['query']." HTTP/1.0\r\n";

	/* リクエストヘッダ */
	$request .= "Host: ".$URL['host']."\r\n";
	$request .= "User-Agent: PHP/".phpversion()."\r\n";

	/* Basic認証用のヘッダ */
	if (isset($URL['user']) && isset($URL['pass'])) {
		$request .= "Authorization: Basic ".base64_encode($URL['user'].":".$URL['pass'])."\r\n";
	}

	/* 追加ヘッダ */
	$request .= $headers;

	/* POSTの時はヘッダを追加して末尾にURLエンコードしたデータを添付 */
	if (strtoupper($method) == "POST") {
		while (list($name, $value) = each($post)) {
			$POST[] = $name."=".urlencode($value);
		}
		$postdata = implode("&", $POST);
		$request .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$request .= "Content-Length: ".strlen($postdata)."\r\n";
		$request .= "\r\n";
		$request .= $postdata;
	} else {
		$request .= "\r\n";
	}

	/* WEBサーバへ接続 */
	$fp = fsockopen($URL['host'], $URL['port']);

	/* 接続に失敗した時の処理 */
	if (!$fp) {
		die("ERROR\n");
	}

	/* 要求データ送信 */
	fputs($fp, $request);

	/* 応答データ受信 */
	$response = "";
	while (!feof($fp)) {
		$response .= fgets($fp, 4096);
	}

	/* 接続を終了 */
	fclose($fp);

	/* ヘッダ部分とボディ部分を分離 */
	$DATA = split("\r\n\r\n", $response, 2);

	if ($debug) $msg  = "<!--\n";
	/* リクエストヘッダをコメントアウトして出力 */
	if ($debug) $msg .= "[REQUEST HEADER]\n".$request;

	/* レスポンスヘッダをコメントアウトして出力 */
	if ($debug) $msg .= "[RESPONSE HEADER]\n".$DATA[0];

	/* レスポンス内容をコメントアウトして出力 */
	if ($debug) $msg .= "[RESPONSE]\n".$DATA[1];
	if ($debug) $msg .= "\n-->\n";
	if ($debug) $DATA[1].=$msg;

	/* メッセージボディを出力 */
	return $DATA[1];
}

?>
